#ifndef KSKD_BINARY_HPP
#define KSKD_BINARY_HPP

#include <string>

long numdec_s_le(const unsigned char* buf, int size);
unsigned long numdec_u_le(const unsigned char* buf, int size);
long numdec_s_be(const unsigned char* buf, int size);
unsigned long numdec_u_be(const unsigned char* buf, int size);

long numdec_s32_le(const unsigned char* buf);
unsigned long numdec_u32_le(const unsigned char* buf);
long numdec_s24_le(const unsigned char* buf);
unsigned long numdec_u24_le(const unsigned char* buf);
long numdec_s16_le(const unsigned char* buf);
unsigned long numdec_u16_le(const unsigned char* buf);
long numdec_s32_be(const unsigned char* buf);
unsigned long numdec_u32_be(const unsigned char* buf);
long numdec_s24_be(const unsigned char* buf);
unsigned long numdec_u24_be(const unsigned char* buf);
long numdec_s16_be(const unsigned char* buf);
unsigned long numdec_u16_be(const unsigned char* buf);

void numenc_s_le(unsigned char* buf, long n, int size);
void numenc_u_le(unsigned char* buf, unsigned long n, int size);
void numenc_s_be(unsigned char* buf, long n, int size);
void numenc_u_be(unsigned char* buf, unsigned long n, int size);

void numenc_s32_le(unsigned char* buf, long n);
void numenc_u32_le(unsigned char* buf, unsigned long n);
void numenc_s24_le(unsigned char* buf, long n);
void numenc_u24_le(unsigned char* buf, unsigned long n);
void numenc_s16_le(unsigned char* buf, long n);
void numenc_u16_le(unsigned char* buf, unsigned long n);
void numenc_s32_be(unsigned char* buf, long n);
void numenc_u32_be(unsigned char* buf, unsigned long n);
void numenc_s24_be(unsigned char* buf, long n);
void numenc_u24_be(unsigned char* buf, unsigned long n);
void numenc_s16_be(unsigned char* buf, long n);
void numenc_u16_be(unsigned char* buf, unsigned long n);

void strdump_hex(std::string& dump, const unsigned char* buf, unsigned long size);
void strdump_bin(std::string& dump, const unsigned char* buf, unsigned long size);

#endif /* KSKD_BINARY_H */
