#ifndef FCEUTOOLS_UTIL_HPP
#define FCEUTOOLS_UTIL_HPP

#include <iostream>
#include <sstream>
#include <string>
#include <vector>

#include "types.hpp"

#define NELEMS(array) (sizeof(array)/sizeof(array[0]))

template<typename T>
bool from_string(const std::string& str, T& value)
{
    std::istringstream in(str);
    in >> value;
    return !in.fail();
}

template<typename T>
bool from_string(const std::string& str, T& value, std::ios_base& (*f)(std::ios_base&))
{
    std::istringstream in(str);
    in >> f >> value;
    return !in.fail();
}

/**
 * ꉞPython݊̂
 */
void lstrip(std::string& str);
void lstrip(std::string& str, const char* ch);
void rstrip(std::string& str);
void rstrip(std::string& str, const char* ch);
void strip(std::string& str);
void strip(std::string& str, const char* ch);
void split(std::vector<std::string>& v, const std::string& str);
void split(std::vector<std::string>& v, const std::string& str, int maxsplit);
void split(std::vector<std::string>& v, const std::string& str, char sep);
void split(std::vector<std::string>& v, const std::string& str, char sep, int maxsplit);
void split(std::vector<std::string>& v, const std::string& str, const std::string& sep);
void split(std::vector<std::string>& v, const std::string& str, const std::string& sep, int maxsplit);
std::string join(const std::string& sep, const std::vector<std::string>& v);

/**
 * SẲsR[h(LF/CRLF/CR)ɑΉ getline()
 * in ̓oCi[hłȂ΂ȂȂ
 */
std::istream& getline_u(std::istream& in, std::string& line);

struct MD5{
    uchar b[16];
};

struct UUID{
    uchar b[16];
};

void md5_from_raw(MD5& md5, const uchar* raw);
void md5_to_raw(const MD5& md5, uchar* raw);
void md5_to_str(const MD5& md5, std::string& str);

void uuid_from_raw(UUID& uuid, const uchar* raw);
void uuid_to_raw(const UUID& uuid, uchar* raw);
bool uuid_from_str(UUID& uuid, const std::string& str);
void uuid_to_str(const UUID& uuid, std::string& str);

void base64_encode(const std::string& src, std::string& dst);
bool base64_decode(const std::string& src, std::string& dst);

#endif /* FCEUTOOLS_UTIL_HPP */
